             @program     prog_code,prog_name
		include		ligne5.h
		include		macros.h
;************** Start of Fargo program ***************

prog_code:
		ClearScr			;dans ligne5.h

		move.l		#0,d0
		move.l		#0,d1
		move.l		#0,d2
		move.l		#0,d3

		move.w		#-2,compteur
		move.b		#120,x
		move.b		#60,y
		move.w		#0,touche
		move.b		#-1,memx
		move.b		#0,memy
		move.b		#112,carrex	;pour faire afficher le carre
		move.b		#60,carrey	;au premier tour
		move.w		#40,maxpixel	;valeur*2

		move.w		#60,-(a7)	;idem pour carre
		move.w		#112,-(a7)	;  "    "    "
		jsr		flib[pixel_on]
		add.l		#4,a7

;depart:
;		tst.w		$75A0		;situation du code touche
;		bne		test
;		jmp		depart

test:
retourpause:	move.w		#0,d0
		move.w		$75A0,touche
		cmp		#$52,touche	;vers le haut
		beq		haut
		cmp		#$53,touche	;haut gauche
		beq		hautgauche
		cmp		#$54,touche	;droite
		beq		droite
		cmp		#$5C,touche	;bas droite
		beq		basdroite
		cmp		#$58,touche	;bas
		beq		bas
		cmp		#$59,touche	;bas gauche
		beq		basgauche
		cmp		#$51,touche	;gauche
		beq		gauche
		cmp		#$56,touche	;haut droite
		beq		hautdroite
		cmp		#$21,touche	;bar d'espace donc fin
		beq		fin
		
test2:
		move.w		#0,d0
		move.b		memx,d0
		add.b		d0,x
		move.b		memy,d0
		add.b		d0,y
		cmp.b		#-1,x		;comparaison avec les
		beq		limitgauche	;limites de l'ecran
		cmp.b		#240,x
		beq		limitdroit
retourlimit:	cmp.b		#-1,y
		beq		limithaut
		cmp.b		#128,y
		beq		limitbas
retourlimit2:
		move.b		y,d0
		move.w		d0,-(a7)
		move.b		x,d0
		move.w		d0,-(a7)
		jsr		flib[find_pixel]
		btst		d0,(a0)
		bne		tstpixel
retourtstcarre:	jsr		flib[pixel_on]
		add.l		#4,a7

		move.w		#700,d0
attente:					;le ralentissement
		sub.w		#1,d0
		cmp.w		#0,d0
		bne		attente

		add.w		#2,compteur
		move.w		compteur,d0
		cmp.w		maxpixel,d0
		bne		sautdecalage
		move.w		#0,d0

		lea.l		coord,a0
		move.b		(a0)+,d0
		move.w		d0,-(a7)
		move.b		(a0),d0
		move.w		d0,-(a7)
		jsr		flib[pixel_off]
		add.l		#4,a7
		sub.w		#1,a0		;pos. 0
		move.w		#0,d0

		move.w		maxpixel,d0
decalage:
		add		#2,a0
		move.b		(a0)+,d1
		move.b		(a0),d2
		sub		#3,a0
		move.b		d1,(a0)+
		move.b		d2,(a0)+
		sub		#2,d0
		cmp		#0,d0
		bne		decalage

		move.w		#0,d0
		move.b		y,(a0)+
		move.b		x,(a0)
		move.w		maxpixel,compteur
		sub.w		#2,compteur

		tst.w		$75A0
		bne		test
		jmp		test2

sautdecalage:
		lea.l		coord,a0
		add.w		compteur,a0
		move.b		y,(a0)+
		move.b		x,(a0)
		
		tst.w		$75A0
		bne		test
		jmp		test2

coord:						;list repertoriant les coordonnees 
		ds.b		2002		;des differents points affiches sur l'ecran

affichedessin:
		lea.l		LCD_MEM,a0
		lea.l		dessin,a1
		add.w		d0,a0
		move.w		#0,d1

boucle1:
		add		#30,a0
		move.b		(a1)+,(a0)
		add.b		#1,d1
		cmp.b		#8,d1
		beq		retourcarre
		jmp		boucle1

tstreussi:
;		tst		$75A0
;		beq		tstreussi

		move.b		carrey,d0
		move.w		d0,-(a7)
		move.b		carrex,d0
		move.w		d0,-(a7)
		jsr		flib[find_pixel]	;pour effacer le carre
		add.w		#4,a7
		
		move.b		#0,d1
boucle4:	add.b		#1,d1
		move.b		#0,(a0)
		add		#30,a0
		cmp.b		#9,d1
		bne		boucle4

		add.w		#40,maxpixel
		cmp.w		#2000,maxpixel
		beq		fingagnant

		move.w		#3600,d0
		jsr		flib[random]
		jmp		affichedessin

retourcarre:
		move.w		#0,d1
		divu.w		#30,d0		;nouvelle valeur de carrey
		move.b		d0,carrey
		swap		d0
		move.b		d0,d1
		mulu.b		#8,d1
		move.b		d1,carrex

		move.l		#0,d0
		move.l		#0,d1

		add		#2,compteur

		jmp		retourtstcarre

tstpixel:
;		move.w		#0,d1
;		move.b		carrex,d0
;		move.b		carrey,d1
;		move.b		x,d2
;		move.b		y,d3
;		tst		$75A0
;		beq		tstpixel


		move.l		#0,d0
		move.l		#0,d1
		move.b		carrex,d0
		move.b		carrey,d2
		move.b		#0,d1
boucle2:	
		cmp.b		x,d0
		beq		tst1
		add.b		#1,d0
		add.b		#1,d1
		cmp.b		#9,d1
		bne		boucle2

		move.b		#0,d1
boucle3:
		cmp.b		y,d2
		beq		tst3
		add.b		#1,d1
		add.b		#1,d2
		cmp.b		#9,d1
		bne		boucle3

		jmp		finperdant

tst1:
		move.b		#0,d1
		move.b		carrey,d2
boucle21:
		cmp.b		y,d2
		beq		tstreussi
		add.b		#1,d1
		add.b		#1,d2
		cmp.b		#9,d1
		beq		finperdant
		jmp		boucle21

tst3:
		move.b		#0,d1
		move.b		carrex,d0
boucle31:
		cmp.b		x,d0
		beq		tstreussi
		add.b		#1,d1
		add.b		#1,d0
		cmp.b		x,d0
		cmp		#9,d1
		beq		finperdant
		jmp		boucle31


limitgauche:
		move.b		#239,x
		jmp		retourlimit
limitdroit:
		move.b		#0,x
		jmp		retourlimit
limithaut:
		move.b		#128,y
		jmp		retourlimit2
limitbas:
		move.b		#0,y
		jmp		retourlimit2
haut:
		move.b		#0,memx
		move.b		#-(1),memy
		jmp		test2

hautgauche:
		move.b		#-(1),memy
		move.b		#-(1),memx
		jmp		test2

droite:
		move.b		#1,memx
		move.b		#0,memy
		jmp		test2

basdroite:
		move.b		#1,memy
		move.b		#1,memx
		jmp		test2

bas:
		move.b		#0,memx
		move.b		#1,memy
		jmp		test2

basgauche:
		move.b		#-(1),memx
		move.b		#1,memy
		jmp		test2

gauche:
		move.b		#-(1),memx
		move.b		#0,memy
		jmp		test2

hautdroite:
		move.b		#1,memx
		move.b		#-(1),memy
		jmp		test2

finperdant:
fingagnant:
		add.l		#4,a7
		jsr		flib[clr_scr]

fin2:
		move.l		#0,d0
		move.w		maxpixel,d1
		divu.w		#2,d1
		move.w		d1,d0
		ChgUnit
		move.l		#0,d0

		lea.l		score,a0
		add.l		#20,a0

		move.b		#48,d0
		add.b		d1,d0
		move.b		d0,(a0)+
		move.b		#48,d0
		add.b		d2,d0
		move.b		d0,(a0)+
		move.b		#48,d0
		add.b		d3,d0
		move.b		d0,(a0)+
		move.b		#48,d0
		add.b		d4,d0
		move.b		d0,(a0)

		SetFont		#1
		WriteStr	#0,#10,#1,score
		WriteStr	#0,#25,#1,score2
		WriteStr	#0,#55,#1,remerciement1
		WriteStr	#0,#70,#1,remerciement2
		WriteStr	#0,#85,#1,remerciement3
		WriteStr	#0,#110,#1,fintext

		move.w		#0,$75B0

bouclefin:	tst		$75B0
		beq		bouclefin
fin:
		rts

x		dc.b		0
y		dc.b		0
memx		dc.b		0
memy		dc.b		0
carrex		dc.b		0
carrey		dc.b		0
touche		dc.w		0
maxpixel	dc.w		0		;maximum de points affiches
compteur	dc.w		0

dessin:		dc.b		%00111100
		dc.b		%01000010
		dc.b		%10100101
		dc.b		%10100101
		dc.b		%10000001
		dc.b		%10111101
		dc.b		%01000010
		dc.b		%00111100
		


;*****************************************************
prog_name:
             dc.b         "Remake de Snake by Froggy",0
score:
		dc.b		"Votre score est de: 0000 pixels.",0
score2:
		dc.b		"Le maximum possible etant 1000 pixels.",0
remerciement1:
		dc.b		"Un Grand Merci a Cpt. Drabob",0
remerciement2:
		dc.b		"(Sector One) qui m'a beaucoup aide a",0
remerciement3:
		dc.b		"comprendre la prog. en assembleur.",0
fintext:
		dc.b		"                     Froggy   06/06/97",0


;*************** End of Fargo program ****************

             	reloc_open
             	add_library     flib
             	add_library     romlib
		reloc_close
             	end

;*****************************************************
